Package org.zkoss.zk.ui.sys

## Class ShadowElementsCtrl

- java.lang.Object
- - org.zkoss.zk.ui.sys.ShadowElementsCtrl

-     public class ShadowElementsCtrl
      extends java.lang.Object

  Utilities for implementing components. (Internal use only)
  Since:
    8.0.0
  Author:
    jumperchen

- - ### Constructor Summary

    Constructors
    Constructor | Description
    --- | ---
    `ShadowElementsCtrl()` |

  - ### Method Summary

    All Methods Static Methods Concrete Methods
    Modifier and Type | Method | Description
    --- | --- | ---
    `static Component[]` | `filterOutShadows​(Component[] shadows)` | Returns the component array filter out shadows if any.
    `static java.lang.Object` | `getCurrentInfo()` | Returns the current shadow element, which is used only by `UiEngine` to communicate with `HtmlShadowElement`.
    `static java.lang.Object` | `getDistributedIndexInfo​(Component host)` | Returns the current distributed index info, which is used only by `HtmlShadowElement`.
    `static void` | `setCurrentInfo​(java.lang.Object shadowInfo)` | Sets the current shadow element, which is used only by `UiEngine` to communicate with `HtmlShadowElement`.
    `static void` | `setDistributedIndexInfo​(Component host, java.lang.Object indexMapInfo)` | Sets the current distributed index info, which is used only by `HtmlShadowElement`.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Constructor Detail

    - #### ShadowElementsCtrl

          public ShadowElementsCtrl()

  - ### Method Detail

    - #### setCurrentInfo

          public static final void setCurrentInfo​(java.lang.Object shadowInfo)

      Sets the current shadow element, which is used only by `UiEngine` to communicate with `HtmlShadowElement`.

      Used only internally.

    - #### getCurrentInfo

          public static final java.lang.Object getCurrentInfo()

      Returns the current shadow element, which is used only by `UiEngine` to communicate with `HtmlShadowElement`.

      Used only internally.

    - #### setDistributedIndexInfo

          public static final void setDistributedIndexInfo​(Component host,
                                                           java.lang.Object indexMapInfo)

      Sets the current distributed index info, which is used only by `HtmlShadowElement`.

      Used only internally.

    - #### getDistributedIndexInfo

          public static final java.lang.Object getDistributedIndexInfo​(Component host)

      Returns the current distributed index info, which is used only by `HtmlShadowElement`.

      Used only internally.

    - #### filterOutShadows

          public static final Component[] filterOutShadows​(Component[] shadows)

      Returns the component array filter out shadows if any. (Most often used for the component developer to invoke `Template.create(Component, Component, org.zkoss.xel.VariableResolver, org.zkoss.zk.ui.util.Composer)` by themselves and invoke this to filter out shadows.